diff --git a/configure.ac b/configure.ac
index 89b0846..69365fe 100644
--- a/configure.ac
+++ b/configure.ac
@@ -49,7 +49,7 @@ AC_TYPE_UINT64_T
 AX_VALGRIND_CHECK
 
 ##########################################################################
-# Which archetecture optimizations will we use
+# Which architecture optimizations will we use
 ##########################################################################
 AS_CASE([$host],
   [x86*], [ARCH=x86],
diff --git a/doc/api_guide_lines.dox b/doc/api_guide_lines.dox
index 0832cae..f3f7799 100644
--- a/doc/api_guide_lines.dox
+++ b/doc/api_guide_lines.dox
@@ -90,7 +90,7 @@ An api with "is" or "has" are both considered @ref boolean questions. They can o
 An example might be a packet interface, you might want to know if it is in promiscuous mode.
 @code odp_bool_t state = odp_pktio_is_promiscuous(pktio handle) @endcode
 
-In addtion you might want to know if it has the ability to be in promiscuous mode.
+In addition you might want to know if it has the ability to be in promiscuous mode.
 @code odp_bool_t state = odp_pktio_has_promiscuous(pktio handle) @endcode
 
 Another case might be if a packet has a vlan flag set
@@ -150,7 +150,7 @@ When an interface is defined in a header file and is intended to to be reused in
 - All the required definitions for the API are to use an underscore, this includes MACROS, typedefs, enums and function names.
 
 @subsection variables Declaring variables
-- Variables shall be declared at the begining of scope, for example :-
+- Variables shall be declared at the beginning of scope, for example :-
 @code
     int start_of_global_scope;
 
diff --git a/example/generator/odp_generator.c b/example/generator/odp_generator.c
index 8ae5b29..cbe93b5 100644
--- a/example/generator/odp_generator.c
+++ b/example/generator/odp_generator.c
@@ -534,7 +534,7 @@ static void print_pkts(int thr, odp_packet_t pkt_tbl[], unsigned len)
 }
 
 /**
- * Main receive funtion
+ * Main receive function
  *
  * @param arg  thread arguments of type 'thread_args_t *'
  */
diff --git a/example/ipsec/odp_ipsec_sa_db.h b/example/ipsec/odp_ipsec_sa_db.h
index c30cbdb..671f266 100644
--- a/example/ipsec/odp_ipsec_sa_db.h
+++ b/example/ipsec/odp_ipsec_sa_db.h
@@ -14,7 +14,7 @@ extern "C" {
 #include <odp_ipsec_misc.h>
 
 /**
- * Security Assocation (SA) data base entry
+ * Security Association (SA) data base entry
  */
 typedef struct sa_db_entry_s {
 	struct sa_db_entry_s *next;      /**< Next entry on list */
@@ -29,7 +29,7 @@ typedef struct sa_db_entry_s {
 } sa_db_entry_t;
 
 /**
- * Security Assocation (SA) data base global structure
+ * Security Association (SA) data base global structure
  */
 typedef struct sa_db_s {
 	uint32_t         index;          /**< Index of next available entry */
diff --git a/helper/include/odp/helper/ip.h b/helper/include/odp/helper/ip.h
index 627c82d..41408a3 100644
--- a/helper/include/odp/helper/ip.h
+++ b/helper/include/odp/helper/ip.h
@@ -154,7 +154,7 @@ _ODP_STATIC_ASSERT(sizeof(odph_ipv6hdr_t) == ODPH_IPV6HDR_LEN, "ODPH_IPV6HDR_T__
  */
 typedef struct ODP_PACKED {
 	uint8_t    next_hdr;     /**< Protocol of next header */
-	uint8_t    ext_len;      /**< Length of this extention in 8 byte units,
+	uint8_t    ext_len;      /**< Length of this extension in 8 byte units,
 				    not counting first 8 bytes, so 0 = 8 bytes
 				    1 = 16 bytes, etc. */
 	uint8_t    filler[6];    /**< Fill out first 8 byte segment */
diff --git a/helper/ring.c b/helper/ring.c
index 721c1fc..67fece9 100644
--- a/helper/ring.c
+++ b/helper/ring.c
@@ -279,7 +279,7 @@ int __odph_ring_mp_do_enqueue(odph_ring_t *r, void * const *obj_table,
 	}
 
 	/*
-	 * If there are other enqueues in progress that preceeded us,
+	 * If there are other enqueues in progress that preceded us,
 	 * we need to wait for them to complete
 	 */
 	while (odp_unlikely(r->prod.tail != prod_head))
diff --git a/platform/linux-generic/odp_pool.c b/platform/linux-generic/odp_pool.c
index f2bf0c7..35e79a0 100644
--- a/platform/linux-generic/odp_pool.c
+++ b/platform/linux-generic/odp_pool.c
@@ -161,7 +161,7 @@ odp_pool_t odp_pool_create(const char *name,
 		params->buf.align = 0; /* tmo.__res2 */
 	}
 
-	/* Default initialization paramters */
+	/* Default initialization parameters */
 	uint32_t p_udata_size = 0;
 	uint32_t udata_stride = 0;
 
diff --git a/platform/linux-generic/odp_rwlock.c b/platform/linux-generic/odp_rwlock.c
index e67169e..47c15ef 100644
--- a/platform/linux-generic/odp_rwlock.c
+++ b/platform/linux-generic/odp_rwlock.c
@@ -49,7 +49,7 @@ void odp_rwlock_write_lock(odp_rwlock_t *rwlock)
 	while (is_locked == 0) {
 		uint32_t zero = 0;
 		cnt = _odp_atomic_u32_load_mm(&rwlock->cnt, _ODP_MEMMODEL_RLX);
-		/* lock aquired, wait */
+		/* lock acquired, wait */
 		if (cnt != 0) {
 			odp_spin();
 			continue;
diff --git a/platform/linux-generic/odp_timer.c b/platform/linux-generic/odp_timer.c
index e5391dc..f51d2de 100644
--- a/platform/linux-generic/odp_timer.c
+++ b/platform/linux-generic/odp_timer.c
@@ -598,7 +598,7 @@ static unsigned odp_timer_pool_expire(odp_timer_pool_t tpid, uint64_t tick)
 	ODP_ASSERT(high_wm <= tpid->param.num_timers);
 	for (i = 0; i < high_wm;) {
 #ifdef __ARM_ARCH
-		/* As a rare occurence, we can outsmart the HW prefetcher
+		/* As a rare occurrence, we can outsmart the HW prefetcher
 		 * and the compiler (GCC -fprefetch-loop-arrays) with some
 		 * tuned manual prefetching (32x16=512B ahead), seems to
 		 * give 30% better performance on ARM C-A15 */
diff --git a/test/performance/odp_atomic.c b/test/performance/odp_atomic.c
index 241295c..861ab83 100644
--- a/test/performance/odp_atomic.c
+++ b/test/performance/odp_atomic.c
@@ -44,7 +44,7 @@ static int odp_test_thread_exit(pthrd_arg *);
 #define MAX_WORKERS           32            /**< Max worker threads */
 /**
  * add_sub_cnt could be any valid value
- * so to excercise explicit atomic_add/sub
+ * so to exercise explicit atomic_add/sub
  * ops. For now using 5..
  */
 #define ADD_SUB_CNT	5
diff --git a/test/validation/odp_cpumask.c b/test/validation/odp_cpumask.c
index b7e18d6..1b1c104 100644
--- a/test/validation/odp_cpumask.c
+++ b/test/validation/odp_cpumask.c
@@ -123,7 +123,7 @@ static void test_odp_cpumask_to_from_str(void)
 		/* check that returned string matches original (with NULL): */
 		CU_ASSERT_NSTRING_EQUAL(buf_out, buf_in, stringlen(buf_in) + 1);
 
-		/* check that no extra buffer writes occured: */
+		/* check that no extra buffer writes occurred: */
 		CU_ASSERT(buf_out[stringlen(buf_in) + 2] == FILLING_PATTERN);
 	}
 